///////////////////////////////////////////////////////////////////
//
// Служебный модуль с набором методов работы с командами приложения
//
// Структура модуля реализована в соответствии с рекомендациями 
// oscript-app-template (C) EvilBeaver
//
///////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////
// Прикладной интерфейс

Процедура ЗарегистрироватьКоманду(Знач ИмяКоманды, Знач Парсер) Экспорт

	ТекстОписания = 
		"     разбираем внешние обработки на исходники штатно через выгрузку 1С 8.3
		|		В каталоге выгрузки создается отдельный подкаталог для каждой внешней обработки
		|		Сохраняется структура подкаталогов, если выгружаем каталог";

	ОписаниеКоманды = Парсер.ОписаниеКоманды(ПараметрыСистемы.ВозможныеКоманды().РазборкаВнешнихОбработок, ТекстОписания);

	Парсер.ДобавитьПозиционныйПараметрКоманды(ОписаниеКоманды, "inputPath", "Путь к каталогу или внешней обработке");
	Парсер.ДобавитьПозиционныйПараметрКоманды(ОписаниеКоманды, "outputPath", "Путь исходников");
	Парсер.ДобавитьКоманду(ОписаниеКоманды);
	
КонецПроцедуры // ЗарегистрироватьКоманду

// Выполняет логику команды
// 
// Параметры:
//   ПараметрыКоманды - Соответствие - Соответствие ключей командной строки и их значений
//   ДополнительныеПараметры (необязательно) - Соответствие - дополнительные параметры
//
Функция ВыполнитьКоманду(Знач ПараметрыКоманды, Знач ДополнительныеПараметры = Неопределено) Экспорт

	УпаковщикВнешнихОбработок = Новый УпаковщикВнешнихОбработок;
	УпаковщикВнешнихОбработок.УстановитьЛог(ДополнительныеПараметры.Лог);

	ДанныеПодключения = ПараметрыКоманды["ДанныеПодключения"];
	
	УпаковщикВнешнихОбработок.Разобрать(
		ОбщиеМетоды.ПолныйПуть(ПараметрыКоманды["inputPath"]), 
		ОбщиеМетоды.ПолныйПуть(ПараметрыКоманды["outputPath"]),
		ДанныеПодключения.СтрокаПодключения, ДанныеПодключения.Пользователь, ДанныеПодключения.Пароль, 
		ПараметрыКоманды["--v8version"]);

	Возврат МенеджерКомандПриложения.РезультатыКоманд().Успех;
КонецФункции // ВыполнитьКоманду
